
#include "includes/template-basic.h"                    

void APPLICATION()
{
    uns8     pomj, myAddr, SPIpacketLength;

    enableSPI();              // povolim si SPI
    appInfo();                // prekopiruji si aplikacni informace BufferINFO
    copyBufferINFO2COM();     // odtud si je presunu do bufferu SPI
    startSPI(32);             // odeslu do terminalu (seznam prikazu)

    mainloop:
    
    while (1)
    {
        clrwdt();             // ani zde nezapominam na WDT
        getStatusSPI();       // zjistim stav PSI

        
        if (_SPIRX)           // prisla mi nejaka data?                        
        {
            
            if (!_SPICRCok)         // pokud nejsou v poradku
                goto restartSPI;    // restartuji SPI

            // jinak...
            //SPIpacketLength = param1;   // zjistim delku prichozich dat 
            pulseLED();                 // bliknu - dam na vedomi ze prijimam

            switch (bufferCOM[0])       // zjistuji jaky ze to prisel prikaz
            {
                
                case 'm':               // prikaz "m" ? - odesilam pozadavek 
                                        // na modul
                    RX = bufferCOM[1] - '0';  
                    // cilem (RX) je modul uvedeny po prikazu "m"... 
                    PIN = 0;
                    // pro jistotu                      
                    DLEN = 0;
                    // delka dat je nulova - poslu prazdny paket
                    setNetworkOne();
                    // tento cluster mi patri - jsem koordinatorem
                    RFTXpacket();        
                    // odeslu sestaveny (prazdny) paket
                    pulseLED();
                    //a bliknu si, aby bylo videt, ze neco delam
                    clrwdt();
                    //waitDelay(10);
                    
                    toutRF = 6;
                    clrwdt();
                    for (pomj=0;pomj<9;pomj++)
                    {
                        if (RFRXpacket())
                        {
                            
                            waitDelay(20);
                            pulseLED();
                            stopSPI();                            
                            copyBufferRF2COM();                            
                            startSPI(DLEN);
                            waitDelay(25);
                            goto mainloop;
                        }
                        pomj++;
                    }
                    goto restartSPI;
                    

                case 'b':
                    pulsingLED();
                    if (bondNewNode())
                    {
                        pomj = param2;    
                        bufferCOM[0] = 'O';
                        bufferCOM[1] = 'K';
                        bufferCOM[2] = ':';
                        bufferCOM[3] = ' ';
                        bufferCOM[4] = param2 + '0';
                    }
                    else
                    {
                        bufferCOM[0] = 'E';
                        bufferCOM[1] = 'R';
                        bufferCOM[2] = 'R';
                        bufferCOM[3] = 'O';
                        bufferCOM[4] = 'R';
                    }
                    stopLED();
                    startSPI(5);
                    continue;

                case 'r':
                    clearAllBonds();
                    bufferCOM[0] = 'E';
                    bufferCOM[1] = 'R';
                    bufferCOM[2] = 'A';
                    bufferCOM[3] = 'S';
                    bufferCOM[4] = 'E';
                    bufferCOM[5] = 'D';
                    startSPI(6);
                    continue;
                    break;
    
                default:
                    break;
            }

          restartSPI:
            startSPI(0);
        }        
    }
}

#pragma packedCdataStrings 0
#pragma cdata[__EEAPPINFO] =  "Prikay: b mX r               "

// ****************************************************************************
